C     PARAMETERS OF SUBROUTINE MOLOD1
C     FHM1    /OUT/VALUE OF LOVE NUMBER H
C     FHK1    /OUT/VALUE OF LOVE NUMBER K
C     FHL1    /OUT/VALUE OF LOVE NUMBER L
C     FACAM   /OUT/AMPLITUDE FACTOR
C     FASTH   /OUT/PHASE LAG(STRAINMETERS ONLY)
C     VITI    /IN/ANGULAR SPEED OF THE WAVE(DEGREE/HOUR)
C     INDI    /IN/COMPONENT(1V,2NS,3EW,5STRAIN)
C     INDIC   /IN/TIDAL SPECIES(1LP,2D,3SD,4TD)
C
      SUBROUTINE MOLOD1(FHM1,FHK1,FHL1,FACAM,FASTH,VITI,INDI,INDIC)
      DOUBLE PRECISION RHO,ALON,ALAT,ATT,GE,AZ
      DOUBLE PRECISION BETA,VITI,VITK1,Q,PS,G,RAY
      DIMENSION G1(4),G2(4)
      COMMON/CONSIT/RHO,ALON,ALAT,ATT,GE,AZ
      DATA VITK1/15.04106864D0/
      IF(INDI.EQ.1.OR.AZ.EQ.0.)FASTH=0.
C
C     MODELE MOLODENSKY 1
C
      GO TO(12,11,12,13),INDIC
C
C     ONDES DIURNES
C
   11 Q=VITI/VITK1
      BETA=1.9D0+41.87D0/(0.2136D0-100.D0*(Q-1.D0)/Q)
      OMEG=BETA*Q*(2.D0-Q)
      FHM1=0.6206-0.0004711*OMEG
      FHK1=0.3070-0.0002383*OMEG
      FHL1=0.0904+0.0000112*OMEG
 1000 FORMAT(12F10.5)
      GO TO 22
C
C     ONDES SEMIDIURNES ET LONGUES PERIODES
C
   12 FHM1=0.6206
      FHK1=0.3070
      FHL1=0.0904
      GO TO 22
C
C     ONDES TERDIURNES
C
   13 FHM1=0.289
      FHK1=0.094
      FHL1=0.0145
C
C     FACTEUR D AMPLITUDE ET PHASE THEORIQUE POUR CHAQUE COMPOSANTE
C
   22 GO TO(20,21,21,89,23,89,20,20),INDI
C
C     COMPOSANTE VERTICALE
C
   20 GN=2
      IF(INDIC.EQ.4)GN=3
      FACAM=1.+2.*FHM1/GN-(GN+1.)*FHK1/GN
      GO TO 30
C
C     COMPOSANTES HORIZONTALES
C
   21 FACAM=1.+FHK1-FHM1
      GO TO 30
C
C     EXTENSOMETRES HORIZONTAUX
C
   23 PS=DTAN(ALAT)*(297.25D0/298.25D0)**2            
      PS=DATAN(PS)
      SPS=DSIN(PS)
      CPS=DCOS(PS)
      S2PS=DSIN(2.D0*PS)
      C2PS=DCOS(2.D0*PS)
      CPS2=CPS*CPS
      SPS2=SPS*SPS
      RAY=1.D0-3.35289D-3*SPS2+ATT/6378.16D0
      G=4.124492D4*RAY/GE
      GP=G*RAY
      CAZ=DCOS(AZ)
      C2AZ=DCOS(AZ*2.D0)
      S2AZ=DSIN(AZ*2.D0)
      CAZ2=CAZ*CAZ
      VMH=FHM1
      VML=FHL1
      IF(INDIC.LT.4)GO TO 10
      V3LP=3.*VML
      VH3LP=VMH-V3LP
      GO TO 14
   10 V2L=VML*2
      VH2L=VMH-V2L
   14 GO TO (88,1,2,3),INDIC
    1 G1(INDIC)=G*(VH2L-V2L*CAZ2)*S2PS
      G2(INDIC)=-G*V2L*S2AZ*CPS
      GO TO 4
    2 G1(INDIC)=G*(VH2L*CPS2+V2L*(C2AZ-CPS2*CAZ2))
      G2(INDIC)=G*V2L*SPS*S2AZ
      GO TO 4
    3 G1(INDIC)=GP*CPS*(VH3LP*CPS2+2.*V3LP*(C2AZ-CAZ2*CPS2))
      G2(INDIC)=GP*CPS*V3LP*SPS*S2AZ
    4 FACAM=SQRT(G1(INDIC)**2+G2(INDIC)**2)
      FASTH=ATAN(G2(INDIC)/G1(INDIC))/RHO
      IF(G1(INDIC).LT.0.)FASTH=FASTH+180.
      IF(FASTH.GT.180.)FASTH=FASTH-360.
   30 RETURN
   88 WRITE(*,8800)
 8800 FORMAT(1H ,'PAS DE MODELE POUR LONGUE PERIODE EXTENSOMETRIQUE')
   89 FACAM=1.
      FASTH=0.
      RETURN
      END
