C
C        ***************************************************************   00010
C                                                                          00020
C        FUNCTION SUBPROGRAM TJUL (VERBEIREN R. - APRIL 1972)              00030
C                                                                          00040
C        PURPOSE                                                           00050
C           COMPUTATION OF THE JULIAN TIME FOR A GIVEN DATE                00060
C                                                                          00070
C        USAGE                                                             00080
C           =TJUL(IAN,MO,JO)                                               00090
C                                                                          00100
C        DESCRIPTION OF THE PARAMETERS                                     00110
C           IAN -  FULL YEAR OR YEARS AFTER 1900                           00120
C           MO  - MONTH OF THE YEAR (1 TO 12)                              00130
C           JO  - DAY OF THE MONTH (1 TO 31)                               00140
C                                                                          00150
C        REMARKS                                                           00160
C           THE VALUES ARE CALCULATED IN DAYS AFTER 1900 JAN 0.5 UT        00170
C           THE SUBSTRACTED VALUE IS 2415020.0                             00180
C                                                                          00200
C        SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED                     00210
C           NONE                                                           00220
C                                                                          00230
C        ***************************************************************   00240
C                                                                          00250
      FUNCTION TJUL(IAN,MO,JO)                                             00000
      DIMENSION NJMO(12)                                                   00260
      DATA NJMO/0,31,59,90,120,151,181,212,243,273,304,334/
      kan=ian
      if(ian.gt.1900)ian=ian-1900
      IAN1=IAN+300
      TNAI=IAN*365+IAN/4-IAN/100+IAN1/400+NJMO(MO)+JO
      TJUL=TNAI-0.5                                                        00290
      IF(IAN-(IAN/4)*4)220,221,220                                         00300
  221 IF(IAN1.EQ.400*(IAN1/400))GO TO 222
      IF(MOD(IAN,100).EQ.0)GO TO 220
  222 IF(MO-2)223,223,224                                                  00320
  223 TJUL=TJUL-1.                                                         00330
  224 IF(IAN)225,220,220                                                   00340
  225 TJUL=TJUL+1.                                                         00350
  220 ian=kan
      RETURN                                                               00360
      END                                                                  00370

