C     Calcul des valeurs theoriques
C     composante verticale: MOLOD or WDH
C     autres composantes: MOLOD only
C
C     PARAMETERS OF SUBROUTINE MOLODW
C     FHM1    /OUT/VALUE OF LOVE NUMBER H (MOLOD ONLY)
C     FHK1    /OUT/VALUE OF LOVE NUMBER K (MOLOD ONLY)
C     FHL1    /OUT/VALUE OF LOVE NUMBER L (MOLOD ONLY)
C     FACAM   /OUT/AMPLITUDE FACTOR (MOLOD ONLY FOR TILT)
C     FASTH   /OUT/PHASE LAG(STRAINMETERS ONLY) (MOLOD ONLY)
C     VITI    /IN/ANGULAR SPEED OF THE WAVE(DEGREE/HOUR)
c     AZ      /IN/azimut for strain component
C     INDI    /IN/COMPONENT(1V,2NS,3EW,4V.DISPL.,5H.STRAIN,6V.STRAIN,
c     7H.DISPL.NS,8H.DISPL.EW)
C     NPT     /IN/ORDER OF POTENTIAL
C     INDIC   /IN/TIDAL SPECIES(1LP,2D,3SD,4TD,5QD)
C     MAT2    /IN/(common DDW) <6 MOLODENSKII , 6,7 DEHANT-DEFRAIGNE-WAHR 
C
      SUBROUTINE MOLODW(FHM1,FHK1,FHL1,FACAM,FASTH,VITI,INDI,NPT,INDIC)
      DOUBLE PRECISION RHO,ALON,ALAT,ATT,GE,AZ,PI2
      DOUBLE PRECISION BETA,VITI,VITK1,Q,PS,G,RAY,FREQ(150),ZLAT
      DIMENSION G1(8),G2(8),GD0(150),GD1(150),GD2(150),IPOT(150)
      COMMON/CONSIT/RHO,ALON,ALAT,ATT,GE,AZ
      COMMON /DDW/FREQ,IPOT,GD0,GD1,GD2,NWDW,MAT2
      DATA VITK1/15.04106864D0/,PI2/1.570796327D0/
      YG2=0.
      YG1=0.
      IF(INDI.EQ.1.OR.AZ.EQ.0.)FASTH=0.
      ZLAT=(PI2-ALAT)
      IF(MAT2.LT.6)GO TO 97
C     modele Wahr-Dehant
C     recherche de l'onde de vitesse VITI dans table(150 ondes max.)
      NDEH=0
      DO 91 I=1,NWDW
      IF(IPOT(I).NE.NPT)GO TO 91
   93 IF((DABS(VITI-FREQ(I))).LE.0.0001D0)GOTO 94
      GOTO 91
   94 IF(NDEH.EQ.0)THEN
      NDEH=I
      ELSE
      PRINT 102,NDEH,I,VITI,FREQ(I),NPT,IPOT(I)
  102 FORMAT(1H ,2I3,' 2 FREQ CORRESPONDENT A LA FREQ PRINCIPALE'
     1,D14.7,' ,',D14.7/,'ORDRE DU POTENTIEL ',2I4)
      STOP
      END IF
   91 CONTINUE
      IF(NDEH.EQ.0)THEN   
   92 PRINT 101,VITI,NPT
c      PRINT 777,(FREQ(K),K=1,NWDW)
c  777 FORMAT(1H ,5D14.8)
  101 FORMAT(1H ,' PAS D EGALITE DE FREQUENCE',E14.8,'POTENTIEL ',I2)
      STOP   
      END IF
C
C     MODELES MOLODENSKY 1 et WAHR-DEHANT-WANG
C
   97 NPT1=NPT-1
      CZLAT2=DCOS(ZLAT)**2
      CZLAT4=CZLAT2*CZLAT2
C      MOLOD: degres 2.0, 2.1, 2.2, 3.3 et 4.4 uniquement
       IF(MAT2.LT.6)THEN
       GO TO(16,13,14),NPT1
       END IF  
   16 GO TO(114,11,12,13,14),INDIC
C
C     ONDES LONGUES PERIODES(INDIC=1)
C     MOLOD(2.0)
  114 FHM1=0.6206
      FHK1=0.3070
      FHL1=0.0904
C     WDH(2.0, 3.0, 4.0)
      IF(MAT2.LT.6)GO TO 22
      GO TO(115,116,117),NPT1
c     ordre 2,0
  115 DENOM=(3.*CZLAT2-1.)
      IF(ABS(DENOM).LT.0.001)GO TO 90
      YG2=2./(SQRT(5.)*DENOM)
      YG1=(3./(4.*SQRT(5.)))*(7.*CZLAT2*((5.*CZLAT2-3.)/DENOM)-3.)
      GO TO 22
c     ordre 3,0
  116 DENOM=(5.*CZLAT2-3.)
      IF(ABS(DENOM).LT.0.001)GO TO 90  
      YG1=(.25*SQRT(11./7.))*(15.-70.*CZLAT2+63.*CZLAT4)/DENOM
      YG2=2.*SQRT(3./7.)/DENOM
      GO TO 22
c     ordre 4,0
  117 DENOM=(3.-30.*CZLAT2+35.*CZLAT4)
      IF(ABS(DENOM).LT.0.001)GO TO 90  
      YG1=(SQRT(13.)/6.)*(-5.+105.*CZLAT2-315.*CZLAT4+231.*CZLAT4*CZLAT2
     *)/DENOM
      YG2=(4.*SQRT(5.)/3.)*(3.*CZLAT2-1.)/DENOM
      GO TO 22
C
C     ONDES DIURNES(INDIC=2)
C     MOLOD(2.1)
   11 Q=VITI/VITK1
      BETA=1.9D0+41.87D0/(0.2136D0-100.D0*(Q-1.D0)/Q)
      OMEG=BETA*Q*(2.D0-Q)
      FHM1=0.6206-0.0004711*OMEG
      FHK1=0.3070-0.0002383*OMEG
      FHL1=0.0904+0.0000112*OMEG
 1000 FORMAT(12F10.5)
C     WDH(2.1, 3.1, 4.1)
      IF(MAT2.LT.6)GO TO 22 
      GO TO(111,112,113),NPT1
c     ordre 2,1      
  111 YG1=SQRT(3./8.)*(7.*CZLAT2-3.)     
      YG2=0.
      GO TO 22
c     ordre 3,1
  112 DENOM=(5.*CZLAT2-1)
      IF(ABS(DENOM).LT.0.001)GO TO 90  
      YG1=(SQRT(55./56.))*(1.-14.*CZLAT2+21.*CZLAT4)/DENOM
      YG2=SQRT(8./7.)/DENOM
      GO TO 22
c     ordre 4,1
  113 DENOM=(7.*CZLAT2-3.)
      IF(ABS(DENOM).LT.0.001)GO TO 90  
      YG1=SQRT(91./120.)*(5.-30.*CZLAT2+33.*CZLAT4)/DENOM
      YG2=SQRT(8./3.)/DENOM
      GO TO 22
C
C     ONDES SEMIDIURNES(INDIC=3) 
C     MOLOD(2.2)
   12 FHM1=0.6206
      FHK1=0.3070
      FHL1=0.0904
C     WDH(2.2, 3.2, 3.3)
      IF(MAT2.LT.6)GO TO 22      
      GO TO(121,122,123),NPT1
c     ordre 2,2      
  121 YG1=(7.*CZLAT2-1.)*(SQRT(3.)/2.)
      GO TO 22
c     ordre 3,2
  122 YG1=(SQRT(11.)/2.)*(3.*CZLAT2-1.)
      GO TO 22
c     ordre 4,2
  123 DENOM=(7.*CZLAT2-1.)
      IF(ABS(DENOM).LT.0.001)GO TO 90  
      YG1=SQRT(91./96.)*(1.-18.*CZLAT2+33.*CZLAT4)/DENOM
      YG2=(2./SQRT(3.))/DENOM
      GO TO 22      
C
C     ONDES TERDIURNES(INDIC=4)
C     MOLOD(3.3)
   13 FHM1=0.289
      FHK1=0.094
      FHL1=0.0145
C     WDH(3.3, 4.3)
      IF(MAT2.LT.6)GO TO 22      
      GO TO(131,132,133),NPT1 
c     erreur
  131 WRITE(*,1310)INDIC,NPT  
      WRITE(10,1310)INDIC,NPT      
 1310 FORMAT(' CONFUSION DANS LES ORDRES : TYPE=',I2,' ORDRE=',I2)
      STOP 
c     ordre 3,3            
  132 YG1=(SQRT(11.)*(9.*CZLAT2-1.))/4.
      GO TO 22
c     ordre 4,3
  133 YG1=SQRT(13./48.)*(11.*CZLAT2-3.)
      go to 22      
C
C     ONDES QUATERDIURNES(INDIC=5)
C     MOLOD(4.4)
   14 FHM1=0.1807
      FHK1=0.0427
      FHL1=0.007
C     WDH(4.4)
      IF(MAT2.LT.6)GO TO 22      
      GO TO(131,131,143),NPT1
c     ordre 4,4            
  143 YG1=SQRT(13./20.)*(11.*CZLAT2-1.)
      GOTO 22

C
C     FACTEUR D AMPLITUDE ET PHASE THEORIQUE POUR CHAQUE COMPOSANTE
C
   22 GO TO(20,21,24,25,23,23,26,27),INDI
C
C     COMPOSANTE VERTICALE
C
   20 IF(MAT2.GE.6)THEN
      FACAM=GD0(NDEH)+ GD1(NDEH)*YG1 + GD2(NDEH)*YG2
      ELSE
      GN=FLOAT(NPT)
      FACAM=1.+2.*FHM1/GN-(GN+1.)*FHK1/GN
      END IF
      GO TO 30
C
C     COMPOSANTE HORIZONTALE NORD-SUD
C
   21 FACAM=1.+FHK1-FHM1
      GO TO 30
C
C     COMPOSANTE HORIZONTALE EST-OUEST
C
   24 FACAM=1.+FHK1-FHM1
      GO TO 30
C
C     VERTICAL DISPLACEMENT
C
   25 FACAM=FHM1
      GO TO 30
C
C     HORIZONTAL DISPLACEMENT
C
   26 FACAM=FHL1
      GO TO 30
   27 FACAM=FHL1
      GO TO 30
C
C
C     EXTENSOMETRES 
C
   23 PS=DTAN(ALAT)*(297.25D0/298.25D0)**2
      PS=DATAN(PS)
      SPS=DSIN(PS)
      CPS=DCOS(PS)
      S2PS=DSIN(2.D0*PS)
      C2PS=DCOS(2.D0*PS)
      CPS2=CPS*CPS
      SPS2=SPS*SPS
      RAY=1.D0-3.35289D-3*SPS2+ATT/6378.16D0
      VMH=FHM1
      VML=FHL1
      if(indi.eq.6)go to 28
c     HORIZONTAL
      G=4.1291125D+04*RAY/GE
      GP=G*RAY
      CAZ=DCOS(AZ)
      C2AZ=DCOS(AZ*2.D0)
      S2AZ=DSIN(AZ*2.D0)
      CAZ2=CAZ*CAZ
      IF(INDIC.LT.4)then
      V2L=VML*2
      VH2L=VMH-V2L
                    else
      V3LP=3.*VML
      VH3LP=VMH-V3LP
                    end if
   15 GO TO (5,1,2,3,89),INDIC
c     D
    1 G1(INDIC)=G*(VH2L-V2L*CAZ2)*S2PS
      G2(INDIC)=-G*V2L*S2AZ*CPS
      GO TO 4
c     SD
    2 G1(INDIC)=G*(VH2L*CPS2+V2L*(C2AZ-CPS2*CAZ2))
      G2(INDIC)=G*V2L*SPS*S2AZ
      GO TO 4
c     TD
    3  G1(indic)=GP*CPS*(VH3LP*CPS2+2.*V3LP*(C2AZ-CAZ2*CPS2))
       G2(indic)=GP*CPS*V3LP*SPS*S2AZ
      go to 4
c     LP
    5 G1(indic)=G*(0.5*VMH*(1.-3.*SPS2)+3.*VML*(SPS2-CPS2*CAZ2))
      G2(indic)=0.
c
    4 FACAM=SQRT(G1(INDIC)**2+G2(INDIC)**2)
      FASTH=ATAN(G2(INDIC)/G1(INDIC))/RHO
      IF(G1(INDIC).LT.0.)FASTH=FASTH+180.
      IF(FASTH.GT.180.)FASTH=FASTH-360.
      go to 30
c     VERTICAL
   28 DPOISS=0.25D0
      VML3=0.0145D+00
      VMH3=0.289D0
      G=41.291125D+03*(dpoiss/(dpoiss-1.D0))*(6.D0*VML-2.D0*VMH)
     1*RAY/GE
      GP=41.291125D+03*(dpoiss/(dpoiss-1.D0))*(6.D0*VML3-2.D0*VMH3)
     1*RAY**2/GE
c      write(10,*)g,gp,vml,vmh
      go to (281,282,283,284,89)indic
c     D  
  282 facam=-G*S2PS
c      G0(2,2)=G(2)*2.17850D+00*CPS*(1.D+00-5.D+00*SPS2)
      go to 30
c     SD
  283 facam=-G*CPS2
c      G0(2,3)=G(2)*7.79424D+00*SPS*CPS2
      go to 30
c     TD
  284 facam=-GP*CPS**3
      go to 30
c     LP
  281 facam=G*0.5D0*(3.D0*sps2-1.D0)
c      G0(2,1)=G(2)*1.11803D0*SPS*(5.D0*SPS2-3.D0)
C
   30 RETURN
C
C     denominateur nul
C   
   90 INDII=INDIC-1
      WRITE(6,9000)INDIC,NPT,ALAT
      WRITE(10,9000)INDIC,NPT,ALAT
 9000 FORMAT(1H ,'DENOMINATEUR NUL POUR FAMILLE ',I1,' ORDRE ',I1,
     *' latitude= ',f10.5)
      STOP
C
C     pas de modelisation
C 
   89 write(*,9900)indi,indic
      write(10,9900)indi,indic
 9900 format(1h ,'no model for this component and family',2I4)
      FACAM=1.
      FASTH=0.
      RETURN
      END
