      SUBROUTINE TDTUTC(IUN6,IPRINT,DTJUL,DDT)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C                                                                      C
C     All variables with D as first character are DOUBLE PRECISION.    C
C                                                                      C
C     Input parameter description:                                     C
C     ----------------------------                                     C
C                                                                      C
C     IUN6...      formatted printer unit.                             C
C     IPRINT...    printout parameter. For IPRINT=0, nothing will be   C
C                  written on unit IUN6. For IPRINT=2, the tables DTX, C
C                  DTJULD and DTY will be printed for the first call   C
C                  of routine TDTUTC.                                  C
C     DTJUL...     reduced Julian date of epoch (Universal time).      C
C                                                                      C
C     Output parameter description:                                    C
C     -----------------------------                                    C
C                                                                      C
C     DDT...       difference ET - UTC   resp. TDT - UTC in seconds    C
C                                             For epochs less 1955.5,  C
C                  for epochs less than 1955.5 DDT is set to 31.59 s   C
C                  ET  is Ephemeris Time.                              C
C                  TDT is Terrestrial Dynamical Time.                  C
C                  UTC is Universal Time Coordinated, as bradcasted by C
C                  radio or GPS satellites.                            C
C                                                                      C
C     The table  DTAB has to be extended, when new data are available. C
C     Change table TDTUTC.DAT                                          C
C                                                                      C
C**********************************************************************C
      IMPLICIT DOUBLE PRECISION (D)
c      IMPLICIT INTEGER*4 (I-N)
      DOUBLE PRECISION DTAB(3,150)
      SAVE NTAB,IWARN,ITAB,DTAB
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     DTAB(1,I) is the year (in decimal form),                         C
C     DTAB(2,I) is the JULIAN date (in days), and                      C
C     DTAB(3,I) is the difference ET minus UTC, or TDT minus UTC       C
C     in sec, as taken from the Astronomical Ephemeris or the Bulletin C
C     of the International Earth Rotation Servive.                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      DATA NTAB/0/,IWARN/1/,ITAB/1/
C     LECTURE DE LA TABLE TDTUTC.DAT
      IF(NTAB.GT.0)GO TO 5
      NTAB=1
    3 READ(15,*)(DTAB(K,NTAB),K=1,3)
      IF(DTAB(1,NTAB).EQ.9999.D0)GO TO 4
c     write(iun6,*)(dtab(k,ntab),k=1,3)
      NTAB=NTAB+1
      IF(NTAB.GT.150)THEN
      WRITE(*,7005)
      WRITE(IUN6,7005)
 7005 FORMAT(1H ,'PLUS DE 150 VALEURS DANS LA TABLE')
      STOP
      END IF
      GO TO 3
    4 NTAB=NTAB-1
      WRITE(IUN6,7003)NTAB
      WRITE(*,7003)NTAB
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Print table for the first call of TDTUTC.                        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    5 IF(IPRINT.NE.2) GOTO 10
      IF(ITAB.EQ.0) GOTO 10
      WRITE(IUN6,7001)
      I=1
      WRITE(IUN6,7002) I,DTAB(1,1),DTAB(2,1),DTAB(3,1)
      WRITE(IUN6,7002) ntab,DTAB(1,ntab),DTAB(2,ntab),DTAB(3,ntab)
   10 CONTINUE
      DTUJD=DTJUL
      IF(DTUJD.LT.DTAB(2,NTAB)) GOTO 11
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     DTUJD exceeds last tabulated epoch DTAB(NTAB,3).                 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
   12 DDT=DTAB(3,NTAB)
      IF(IWARN.EQ.1) WRITE(IUN6,7051) DTAB(1,NTAB)
      IF(IWARN.EQ.1) WRITE(*,7051)    DTAB(1,NTAB)
      IWARN=0
      GO TO 99
   11 IF(DTUJD.LT.DTAB(2,1))THEN
      DDT=DTAB(3,1)
      GO TO 99
      END IF
      DO  20  I=2,NTAB
      IF(DTUJD-DTAB(2,I))   21,22,20
   22 DDT=DTAB(3,I)
      GO TO 99
   21 GOTO  23
   20 CONTINUE
      I=NTAB
   23 DDT=(DTAB(3,I)*(DTUJD-DTAB(2,I-1))-DTAB(3,I-1)*(DTUJD-DTAB(2,I)))/
     1(DTAB(2,I)-DTAB(2,I-1))
   99 IF(ITAB.EQ.1)THEN
      WRITE(IUN6,7052)DTUJD,DDT
      ITAB=0
      END IF
      RETURN
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Format statements:                                               C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 7001 FORMAT(//' Routine TDTUTC, FTN 77.'//
     1' List of tables:'//
     2'       No.           Juld            DTX       DTY'//)
 7002 FORMAT(I10,2F15.5,F10.3)
 7003 FORMAT(/' DIMENSION DE LA TABLE TDTUTC',I5)
 7051 FORMAT(/' ***** Warning from routine TDTUTC.'/
     1' ***** Epoch exceeds the last tabulated value:',F10.5/
     2' ***** DDT of last tabulated epoch is used.'/
     3' ***** Please try to update tabels in routine ETMUC.'/)
 7052 FORMAT(1H ,' TJUL=',f12.3,' DIFFERENCE TDT-UTC=',F7.3,'SEC'/)
      END
